//Raygun
//By Aware14(coolbro) and Ghille(Ghilles the culbro for real)
//Herb Productions.inc

datablock AudioProfile(RaygunfireSound)
{
   filename    = "Add-Ons/Weapon_Raygun/Raygunfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(RaygunExplosionParticle)

{
 dragCoefficient = 1;
 windCoefficient = 0;
 gravityCoefficient = 0;
 inheritedVelFactor = 0.2;
 constantAcceleration = 0;
 lifetimeMS = 750;
 lifetimeVarianceMS = 250;
 textureName = "base/data/particles/cloud";
 spinSpeed = 0;
 spinRandomMin = -1000;
 spinRandomMax = 1000;
 useInvAlpha = false;
 colors[0] = "0.0 0.9 0.1 0.4";
 colors[1] = "0.1 0.9 0.0 0.4";
 colors[2] = "0.1 0.9 0.0 0.0";
 sizes[0] = 2;
 sizes[1] = 0.20;
 sizes[2] = 0.20;
 times[0] = 0;
 times[1] = 0.2;
 times[2] = 1;
};

datablock ParticleEmitterData(RaygunExplosionEmitter)
{
 ejectionPeriodMS = 5;
 periodVarianceMS = 4;
 ejectionVelocity = 8;
 velocityVariance = 0.2;
 ejectionOffset = 1;
 thetaMin = 0;
 thetaMax = 180;
 phiReferenceVel = 720;
 phiVariance = 20;
 overrideAdvance = false;
 particles = "RaygunExplosionParticle";
};

datablock ExplosionData(RaygunExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;
   particleEmitter = RaygunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;
   emitter[0] = RaygunExplosionEmitter;
   faceViewer     = true;
   explosionScale = "1 1 1";
   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};
AddDamageType("RayGunHeadShot",   '<bitmap:Add-Ons/Weapon_Raygun/CI_Raygun> %1',    '%2 <bitmap:Add-Ons/Weapon_Raygun/CI_Raygun> %1',0.2,1);
datablock ProjectileData(RaygunHeadshot)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::RayGun;
   radiusDamageType    = $DamageType::RayGun;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse     = 000;
   verticalImpulse  = 100;
   explosion           = RaygunExplosion;
   bloodExplosion        = RaygunExplosionEmitter;
   particleEmitter       = HorseRayTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "Raygun Laser";
};

AddDamageType("RayGun",   '<bitmap:Add-Ons/Weapon_Raygun/CI_Raygun> %1',    '%2 <bitmap:Add-Ons/Weapon_Raygun/CI_Raygun> %1',0.2,1);
datablock ProjectileData(RaygunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::RayGun;
   radiusDamageType    = $DamageType::RayGun;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
   impactImpulse     = 000;
   verticalImpulse  = 100;
   explosion           = RaygunExplosion;
   bloodExplosion        = RaygunExplosionEmitter;
   particleEmitter       = HorseRayTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;
   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;
   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   uiName = "Raygun Laser";
};

//////////

// item //

//////////

datablock ItemData(RayGunItem)
{
 category = "Weapon";  // Mission editor category
 className = "Weapon"; // For inventory system
  // Basic Item Properties
 shapeFile = "./Raygun.dts";
 rotate = false;
 mass = 1;
 density = 0.2;
 elasticity = 0.2;
 friction = 0.6;
 emap = true;
 //gui stuff
 uiName = "Raygun";
 iconName = "./UI_Raygun";
 doColorShift = true;
 colorShiftColor = "0.25 0.25 0.25 1.000";
  // Dynamic properties defined by the scripts
 image = RaygunImage;
 canDrop = true;
 maxAmmo = 20;
        canReload = 1;
};

////////////////

//weapon image//

////////////////

datablock ShapeBaseImageData(RaygunImage)
{
   // Basic Item properties
  shapeFile = "./Raygun.dts";
   emap = true;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;
   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
   // Projectile && Ammo.
   item = RaygunItem;
   ammo = " ";
   projectile = RaygunProjectile;
   projectileType = Projectile;
   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   doColorShift = true;
   colorShiftColor = RaygunItem.colorShiftColor;//"0.400 0.196 0 1.000";

stateName[0]    = "Activate";
 stateTimeoutValue[0]   = 0.3;
 stateWaitForTimeout[0]   = true;
 stateTransitionOnTimeout[0]  = "LoadCheckA";
 stateSound[0]    = weaponSwitchSound;
 
 stateName[1]                     = "Ready";
 stateTransitionOnTriggerDown[1]  = "Fire";
 stateAllowImageChange[1]         = true;
 stateTimeoutValue[1]   = 0.01;
 stateTransitionOnNoAmmo[1]  = "Reload";
 
 stateName[2]                     = "Fire";
 stateTransitionOnTimeout[2]      = "FireLoadCheckA";
 stateTimeoutValue[2]             = 0.08;
 stateFire[2]                     = true;
 stateAllowImageChange[2]         = false;
 stateSequence[2]   = "Fire";
 stateScript[2]    = "onFire";
 stateWaitForTimeout[2]   = true;
 stateSound[2]    = RaygunFireSound;
  stateEjectShell[2] = false;  
 
 stateName[4]    = "LoadCheckA";
 stateScript[4]    = "onLoadCheck";
 stateTimeoutValue[4]   = 0.05;
 stateTransitionOnTimeout[4]  = "LoadCheckB";
 
 stateName[5]    = "LoadCheckB";
 stateTransitionOnAmmo[5]  = "Ready";
 stateTransitionOnNoAmmo[5]  = "Reload";
 stateName[6]    = "Reload";
 stateTimeoutValue[6]   = 0.7;
 stateScript[6]    = "onReloadStart";
 stateTransitionOnTimeout[6]  = "Wait";
 stateWaitForTimeout[6]   = true;
 stateSound[6]    = Block_MoveBrick_Sound;
 
 stateName[7]    = "Wait";
 stateTimeoutValue[7]   = 0.4;
 stateScript[7]    = "onReloaded";
 stateTransitionOnTimeout[7]  = "Ready";
 stateSound[7]    = Block_PlantBrick_Sound;
 
 stateName[8]    = "FireLoadCheckA";
 stateScript[8]    = "onLoadCheck";
 stateTimeoutValue[8]   = 0.01;
 stateTransitionOnTimeout[8]  = "FireLoadCheckB";
 
 stateName[9]    = "FireLoadCheckB";
 stateTransitionOnAmmo[9]  = "Smoke";
 stateTransitionOnNoAmmo[9]  = "ReloadSmoke";
 
 stateName[10]     = "Smoke";
 stateTimeoutValue[10]   = 0.2;
 stateTransitionOnTriggerUp[10]     = "Ready";
 
 stateName[11]     = "ReloadSmoke";
 stateTimeoutValue[11]   = 0.2;
 stateTransitionOnTimeout[11]  = "Reload";
 
};
function RaygunImage::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}
function RaygunImage::onReloaded(%this,%obj,%slot)
{
        %obj.playThread(2, shiftAway);
        
        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
        %obj.setImageAmmo(%slot,1);

	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "20 " @ "", 4, 2, 3, 4); 
}
function RaygunImage::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}
function RaygunImage::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "20 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, shiftAway);
                                
%projectile = %this.projectile;
  %spread = 0.0009;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

function RaygunProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
  if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer")
  {
    if(%col.getClassName() $= "AIPlayer")
    {
      %oldClient = %col.client;
      %col.client = BotConnection;
      %hitBoxList = getHitbox(%obj,%col,%pos);
      %col.client = %oldClient;
    }
    else
    {
      %hitBoxList = getHitbox(%obj,%col,%pos);
    }
    if(strReplace(%hitBoxList,"headskin","BAM") $= %hitBoxList)
    {
      parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
    }
    else
    {
      %col.damage(%obj,%pos,120 / %obj.getScale(),$DamageType::InterventionHeadshot);
    }
  }
  else
  {
    parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
  }
}

